import ac, acsys
import sys, os, platform, codecs
# import configparser

# import libraries
if platform.architecture()[0] == "64bit":
    sysdir=os.path.dirname(__file__)+'/stdlib64'
else:
    sysdir=os.path.dirname(__file__)+'/stdlib'
sys.path.insert(0, sysdir)
os.environ['PATH'] = os.environ['PATH'] + ";."
from ctypes import *
from RaceResults_shared_mem import RaceResultsShared

sharedMem = RaceResultsShared()
pluginVersion = "1.0.0"
timer = 0
btnSave = 0

def updateSharedMemory():
  global sharedMem
  sharedmem = sharedMem.getsharedmem()
  sharedmem.numVehicles = ac.getCarsCount()
  sharedmem.focusVehicle = ac.getFocusedCar()
  #now we'll build the slots, so we later know every single (possible) car
  carIds = range(0, ac.getCarsCount(), 1)
  for carId in carIds:
    #first we'll check wether there is a car for this id; as soon it returns -1
    #it's over
    if str(ac.getCarName(carId)) == '-1':
      break
    else:
      sharedmem.vehicleInfo[carId].carId = carId
      sharedmem.vehicleInfo[carId].driverName = ac.getDriverName(carId).encode('utf-8')
      sharedmem.vehicleInfo[carId].carModel = ac.getCarName(carId).encode('utf-8')
      sharedmem.vehicleInfo[carId].speedMS = ac.getCarState(carId, acsys.CS.SpeedMS)
      sharedmem.vehicleInfo[carId].bestLapMS = ac.getCarState(carId, acsys.CS.BestLap)
      sharedmem.vehicleInfo[carId].lapCount = ac.getCarState(carId, acsys.CS.LapCount)
      sharedmem.vehicleInfo[carId].currentLapInvalid = ac.getCarState(carId, acsys.CS.LapInvalidated)
      sharedmem.vehicleInfo[carId].currentLapTimeMS = ac.getCarState(carId, acsys.CS.LapTime)
      sharedmem.vehicleInfo[carId].lastLapTimeMS = ac.getCarState(carId, acsys.CS.LastLap)
      sharedmem.vehicleInfo[carId].worldPosition = ac.getCarState(carId, acsys.CS.WorldPosition)
      sharedmem.vehicleInfo[carId].isCarInPitline = ac.isCarInPitline(carId)
      sharedmem.vehicleInfo[carId].isCarInPit = ac.isCarInPit(carId)
      sharedmem.vehicleInfo[carId].carLeaderboardPosition = ac.getCarLeaderboardPosition(carId)
      sharedmem.vehicleInfo[carId].carRealTimeLeaderboardPosition = ac.getCarRealTimeLeaderboardPosition(carId)
      sharedmem.vehicleInfo[carId].spLineLength = ac.getCarState(carId, acsys.CS.NormalizedSplinePosition)
      sharedmem.vehicleInfo[carId].isConnected = ac.isConnected(carId)
      if sharedmem.vehicleInfo[carId].lapCountLast != sharedmem.vehicleInfo[carId].lapCount:
        sharedmem.vehicleInfo[carId].totalTimeMS += sharedmem.vehicleInfo[carId].lastLapTimeMS
        sharedmem.vehicleInfo[carId].lapCountLast = sharedmem.vehicleInfo[carId].lapCount
      else:
        sharedmem.vehicleInfo[carId].totalTimeMS = 0

def appSaveNow(*args):
  global sharedMem
  sharedmem = sharedMem.getsharedmem()
  cars = list(sharedmem.vehicleInfo)
  cars.sort(key=lambda car: car.carRealTimeLeaderboardPosition, reverse=False)
  with codecs.open('apps\\python\\RaceResults\\results.txt', 'w', 'utf_8', errors='ignore') as f:
    f.write('Pos\tDriver Name\tCar Model\tTotal Time\tBest Lap\n')
    cars.sort(key=lambda car: car.carLeaderboardPosition, reverse=False)
    for index in range(64):
      if cars[index].carLeaderboardPosition!=0:
        f.write(  str(cars[index].carLeaderboardPosition) + '\t'
                + str(cars[index].driverName).encode('ascii', 'ignore').decode('ascii').strip().replace("b'", "").replace("'","") + '\t'
                + str(cars[index].carModel).encode('ascii', 'ignore').decode('ascii').strip().replace("b'", "").replace("'","") + '\t'
                + timeToString(cars[index].totalTimeMS) + '\t'
                + timeToString(cars[index].bestLapMS) + '\n'
                )

def acMain(ac_version):
  global appWindow,sharedMem,btnSave

  appWindow = ac.newApp("RaceResults")
  ac.setSize(appWindow, 200, 60)

  btnSave = ac.addButton(appWindow, "save now")
  ac.setPosition(btnSave, 50, 25)
  ac.setSize(btnSave, 100, 20)
  ac.addOnClickedListener(btnSave, appSaveNow)

  sharedmem = sharedMem.getsharedmem()
  sharedmem.serverName = ac.getServerName().encode('utf-8')
  sharedmem.acInstallPath = os.path.abspath(os.curdir).encode('utf-8')
  sharedmem.isInternalMemoryModuleLoaded = 0
  sharedmem.pluginVersion = pluginVersion.encode('utf-8')

  ac.log("RaceResults started")
  ac.console("RaceResults started")

  return "RaceResults"

def acUpdate(deltaT):
  global timer
  timer += deltaT
  if timer > 0.05:
    updateSharedMemory()
    timer = 0

def acShutdown():
  appSaveNow()

def timeToString(time):
    if time <= 0:
        return "-:--.---"
    else:
        return "{:d}:{:0>2d}.{:0>3d}".format(int(time/60000), int((time%60000)/1000), time%1000)

def formatTimeGap(time):
    laptime_sec = time//1000
    laptime_min = laptime_sec//60
    laptime_sec = laptime_sec%60
    laptime_milisec = time%1000
    if time <= 0:
        return ""
    elif laptime_min == 0:
        return "+{:>2}.{:03}".format(laptime_sec,laptime_milisec)
    else:
        return "+{:>2}:{:02}.{:03}".format(laptime_min,laptime_sec,laptime_milisec)
